<?php
namespace Claromentis\People;

$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_98966bfaaccbeb4658a87a97e8fa" . "fb11" => base64_decode("REVMRVRFIEZST00gb3JnX2NoYXJ0IFdIRVJFIGlkPWludDp1aWQ" . "="), "_736432b3f9e1cd2ec" . "77cd6f2ba0c3bdb" => base64_decode("U0VMRUNUIGJvc3NfaWQgRlJPTSBvcmdfY2hhcnQgV0hFUkUgaWQ9aW50OnVpZCBBTkQgYm9zc19pZDw+aW50OnVpZCBPUkRFUiBCWSBp" . "c19wcmltYXJ5"), "_88aa4158bbda1" . "ad77d138780ea6" . "8e38b" => base64_decode("U0VMRUNUIGlkLCBpc19wcmltYXJ5IEZST00g" . "b3JnX2NoYXJ0IFdIRVJFIGJvc3NfaWQ9aW50" . "OnVpZA=="), "_e02488992f8ce86b" . "71d9f32b29fe215c" => base64_decode("SU5TRVJUIElOVE8gb3JnX2NoYXJ0IChpZCwgYm9zc19pZCwgaXNfcHJpbWFyeSkgVkFMVUVTIChpbnQ" . "6dWlkLCBpbnQ6bWFuYWdlcl9pZCwgMSk="), "_7f628626dd1d55c71b1fc0" . "932ffd1d2c" => base64_decode("aXNfYXJyYXk" . "="), "_62d701c3c5" . "3404f06345e" . "b35720a47b4" => base64_decode("aXNfbnV" . "tZXJpYw" . "=="), "_680cc2b8220e94c" . "8c32b8bc7c65519b" . "4" => base64_decode("aXNfa" . "W50"), "_2f700090" . "654ea43a4" . "fec1f8ca5" . "084d38" => base64_decode("REVMRVRFIEZST00gb3JnX2No" . "YXJ0IFdIRVJFIGJvc3NfaWQ9" . "aW50OnVpZA=="));
use Claromentis\Core\DAL\Interfaces\DbInterface;







class UsersHierarchyService
{
    
    
    
    
    protected $db;
    public function __construct(DbInterface $db)
    {
        $this->db = $db;
    }
    
    
    
    
    
    
    
    
    public function SetManager($user_id, $_b324f64f5346fe6cd20483e208d94430) : bool
    {
        if (!$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_62d701c3c53404f" . "06345eb35720a47b" . "4"]($user_id) || !$user_id) {
            return false;
        }
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_98966bfaaccbeb4658a87a97e8f" . "afb11"], $user_id);
        if ($_b324f64f5346fe6cd20483e208d94430 === null) {
            return true;
        }
        if (!$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_680cc2b8220e94c8c32b8b" . "c7c65519b4"]($_b324f64f5346fe6cd20483e208d94430)) {
            return false;
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_e0248899" . "2f8ce86b7" . "1d9f32b29" . "fe215c"], $user_id, $_b324f64f5346fe6cd20483e208d94430);
        return true;
    }
    
    
    
    
    
    
    
    public function SetSubordinates($user_id, $_9b25bd1f846ab3177a43069b54248349)
    {
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_2f700090" . "654ea43a4" . "fec1f8ca5" . "084d38"], $user_id);
        
        
        if (!$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_7f628626dd1d55c" . "71b1fc0932ffd1d2" . "c"]($_9b25bd1f846ab3177a43069b54248349)) {
            return false;
        }
        
        
        foreach ($_9b25bd1f846ab3177a43069b54248349 as $_f19d55a3cc79997bcb33f250cc2ee482) {
            if (!$this->SetManager($_f19d55a3cc79997bcb33f250cc2ee482, $user_id)) {
                return false;
            }
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetManager($user_id)
    {
        list($_b324f64f5346fe6cd20483e208d94430) = $this->db->query_row($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_736432b3f9e1cd2ec77cd6f2ba0c" . "3bdb"], $user_id, $user_id);
        return $_b324f64f5346fe6cd20483e208d94430 ?? 0;
    }
    
    
    
    
    
    
    
    public function GetSubordinates($user_id)
    {
        $_189840d11056515e52402d1412a0b6e4 = $this->db->query($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_88aa4158bb" . "da1ad77d138" . "780ea68e38b"], $user_id);
        $_5bbedf94f4628faff30d9e300695d342 = array();
        while ($row = $_189840d11056515e52402d1412a0b6e4->fetchRow()) {
            if (!$row[1] && self::GetManager($row[0]) != $user_id) {
                continue;
            }
            $_5bbedf94f4628faff30d9e300695d342[] = $row[0];
        }
        return $_5bbedf94f4628faff30d9e300695d342;
    }
}